org.apache.ignite.internal.processors.cache.distributed.near

## Class GridNearTxLocal

- java.lang.Object
- - org.apache.ignite.internal.util.lang.GridMetadataAwareAdapter
  - - org.apache.ignite.internal.processors.cache.transactions.IgniteTxAdapter
    - - org.apache.ignite.internal.processors.cache.transactions.IgniteTxLocalAdapter
      - - org.apache.ignite.internal.processors.cache.distributed.dht.GridDhtTxLocalAdapter
        - - org.apache.ignite.internal.processors.cache.distributed.near.GridNearTxLocal

All Implemented Interfaces:
  Externalizable, Serializable, AutoCloseable, IgniteInternalTx, IgniteTxLocalEx, GridTimeoutObject

    public class GridNearTxLocal
    extends GridDhtTxLocalAdapter

Replicated user transaction.

See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class org.apache.ignite.internal.processors.cache.transactions.IgniteTxLocalAdapter

`IgniteTxLocalAdapter.FinishClosure<T>, IgniteTxLocalAdapter.PLC1<T>, IgniteTxLocalAdapter.PLC2<T>, IgniteTxLocalAdapter.PMC<T>, IgniteTxLocalAdapter.PostLockClosure1<T>, IgniteTxLocalAdapter.PostLockClosure2<T>, IgniteTxLocalAdapter.PostMissClosure<T>`

### Nested classes/interfaces inherited from class org.apache.ignite.internal.util.lang.GridMetadataAwareAdapter

`GridMetadataAwareAdapter.EntryKey`

### Nested classes/interfaces inherited from interface org.apache.ignite.internal.processors.cache.transactions.IgniteInternalTx

`IgniteInternalTx.FinalizationStatus`

### Field Summary

### Fields inherited from class org.apache.ignite.internal.processors.cache.distributed.dht.GridDhtTxLocalAdapter

`dhtMap, explicitLock, mapped, nearMap`

### Fields inherited from class org.apache.ignite.internal.processors.cache.transactions.IgniteTxLocalAdapter

`commitErr, doneFlag, implicitRes, minVer, needRetVal, txState`

### Fields inherited from class org.apache.ignite.internal.processors.cache.transactions.IgniteTxAdapter

`cctx, concurrency, endVer, implicit, internal, invalidate, isDone, isolation, loc, log, nodeId, onePhaseCommit, startTime, startVer, storeEnabled, subjId, syncCommit, syncRollback, taskName, taskNameHash, threadId, timeout, topVer, transform, txNodes, txSize, writeVer, xidVer`

### Constructor Summary

Constructors
Constructor and Description
`GridNearTxLocal()` Empty constructor required for `Externalizable`.
`GridNearTxLocal(GridCacheSharedContext ctx, boolean implicit, boolean implicitSingle, boolean sys, byte plc, TransactionConcurrency concurrency, TransactionIsolation isolation, long timeout, boolean storeEnabled, int txSize, UUID subjId, int taskNameHash)`

### Method Summary

Methods
`protected IgniteCacheExpiryPolicy` `accessPolicy(GridCacheContext cacheCtx, Collection<KeyCacheObject> keys)`
`protected IgniteCacheExpiryPolicy` `accessPolicy(GridCacheContext ctx, IgniteTxKey key, javax.cache.expiry.ExpiryPolicy expiryPlc)`
`void` `addKeyMapping(IgniteTxKey key, ClusterNode node)` Adds key mapping to dht mapping.
`protected IgniteInternalFuture<Boolean>` `addReader(long msgId, GridDhtCacheEntry cached, IgniteTxEntry entry, AffinityTopologyVersion topVer)` Adds reader to cached entry.
`protected void` `clearPrepareFuture(GridDhtTxPrepareFuture fut)` Removes previously created prepare future from atomic reference.
`void` `close()` Ends the transaction.
`boolean` `colocated()`
`boolean` `colocatedLocallyMapped()`
`void` `colocatedLocallyMapped(boolean colocatedLocallyMapped)`
`IgniteInternalFuture<IgniteInternalTx>` `commitAsync()` Asynchronously commits this transaction by initiating `two-phase-commit` process.
`IgniteInternalFuture<IgniteInternalTx>` `commitAsyncLocal()` Commits local part of colocated transaction.
`IgniteInternalFuture<?>` `currentPrepareFuture()`
`boolean` `enforceSerializable()` For Partitioned caches, this flag is `false` for remote DHT and remote NEAR transactions because serializability of transaction is enforced on primary node.
`protected GridCacheEntryEx` `entryEx(GridCacheContext cacheCtx, IgniteTxKey key)` Gets cache entry for given key.
`protected GridCacheEntryEx` `entryEx(GridCacheContext cacheCtx, IgniteTxKey key, AffinityTopologyVersion topVer)` Gets cache entry for given key and topology version.
`boolean` `finish(boolean commit)` Finishes transaction (either commit or rollback).
`boolean` `hasRemoteLocks()`
`void` `hasRemoteLocks(boolean hasRemoteLocks)`
`IgniteInternalFuture<Void>` `loadMissing(GridCacheContext cacheCtx, boolean readThrough, boolean async, Collection<KeyCacheObject> keys, boolean skipVals, boolean needVer, boolean keepBinary, GridInClosure3<KeyCacheObject,Object,GridCacheVersion> c)`
`<K> IgniteInternalFuture<GridCacheReturn>` `lockAllAsync(GridCacheContext cacheCtx, Collection<? extends K> keys, boolean implicit, boolean read, long accessTtl, boolean skipStore, boolean keepBinary)`
`boolean` `markExplicit(UUID nodeId)`
`void` `markForBackupCheck()` Marks transaction to check if commit on backup.
`boolean` `near()`
`protected IgniteUuid` `nearFutureId()`
`boolean` `nearLocallyMapped()`
`void` `nearLocallyMapped(boolean nearLocallyMapped)`
`protected UUID` `nearNodeId()`
`GridCacheVersion` `nearXidVersion()`
`boolean` `needCheckBackup()`
`boolean` `onNeedCheckBackup()`
`boolean` `onOwnerChanged(GridCacheEntryEx entry, GridCacheMvccCandidate owner)` Callback invoked whenever there is a lock that has been acquired by this transaction for any of the participating entries.
`void` `onRemap(AffinityTopologyVersion topVer)`
`Collection<IgniteTxEntry>` `optimisticLockEntries()` Gets a list of entries that needs to be locked on the next step of prepare stage of optimistic transaction.
`void` `optimisticLockEntries(Collection<IgniteTxEntry> optimisticLockEntries)`
`boolean` `ownsLock(GridCacheEntryEx entry)`
`boolean` `ownsLockUnsafe(GridCacheEntryEx entry)`
`IgniteInternalFuture<?>` `prepareAsync()` Prepare stage.
`IgniteInternalFuture<GridNearTxPrepareResponse>` `prepareAsyncLocal(Collection<IgniteTxEntry> reads, Collection<IgniteTxEntry> writes, Map<UUID,Collection<UUID>> txNodes, boolean last)` Prepares next batch of entries in dht transaction.
`boolean` `removeMapping(UUID nodeId)`
`IgniteInternalFuture<IgniteInternalTx>` `rollbackAsync()` Asynchronously rollback this transaction.
`IgniteInternalFuture<IgniteInternalTx>` `rollbackAsyncLocal()` Rolls back local part of colocated transaction.
`protected void` `sendFinishReply(boolean commit, Throwable err)`
`boolean` `syncCommit()`
`boolean` `syncRollback()`
`String` `toString()`
`protected void` `updateExplicitVersion(IgniteTxEntry txEntry, GridCacheEntryEx entry)` Updates explicit version for tx entry based on current entry lock owner.

### Methods inherited from class org.apache.ignite.internal.processors.cache.distributed.dht.GridDhtTxLocalAdapter

`addEntry, addInvalidPartition, addLockTransactionNode, chainOnePhasePrepare, commitOnPrepare, explicitLock, explicitLock, lockTransactionNodes, mapExplicitLocks, nearOnOriginatingNode, nearOnOriginatingNode, needsCompletedVersions, pendingVersions, pendingVersions, rollback`

### Methods inherited from class org.apache.ignite.internal.processors.cache.transactions.IgniteTxLocalAdapter

`activeCachesDeploymentEnabled, activeCachesDeploymentEnabled, addActiveCache, addEntry, allEntries, alternateVersions, batchStoreCommit, checkValid, commit, commitAfterLock, commitError, commitError, committedVersions, completedBase, completedVersions, empty, entry, entryExpireTime, entryTtl, eventNodeId, getAllAsync, hasInterceptor, hasWriteKey, implicitSingleResult, implicitSingleResult, init, initResult, invokeAsync, invokeAsync, isStarted, masterNodeIds, minVersion, needReturnValue, needReturnValue, originatingNodeId, peek, postLockWrite, prepare, putAllAsync, putAllDrAsync, putAsync, readEntries, readMap, readSet, removeAllAsync, removeAllDrAsync, rolledbackVersions, seal, sendTransformedValues, tmFinish, txState, userCommit, userPrepare, userRollback, writeEntries, writeMap, writeSet`

### Methods inherited from class org.apache.ignite.internal.processors.cache.transactions.IgniteTxAdapter

`applyTransformClosures, checkInternal, commitVersion, commitVersion, concurrency, conflictResolve, dht, done, endTime, endVersion, endVersion, equals, evictNearEntry, finalizationStatus, finishFuture, hashCode, hasTransforms, implicit, implicitSingle, internal, invalidate, invalidPartitions, ioPolicy, isInvalidate, isNearLocallyMapped, isolation, isRollbackOnly, isSystemInvalidate, local, localResult, lockTimeout, log, markFinalizing, markPreparing, nodeId, onePhaseCommit, onePhaseCommit, onTimeout, optimistic, otherNodeId, ownedVersion, pessimistic, proxy, readCommitted, readExternal, readResolve, remainingTime, repeatableRead, replicated, resolveTaskName, serializable, setRollbackOnly, size, startTime, startVersion, state, state, storeEnabled, storeEnabled, storeUsed, subjectId, syncCommit, syncRollback, system, systemInvalidate, taskNameHash, threadId, timedOut, timeout, timeout, timeoutId, topologyVersion, topologyVersion, topologyVersionSnapshot, transactionNodes, transactionNodes, uncommit, updateNearCache, user, writeExternal, writeVersion, writeVersion, xid, xidVersion`

### Methods inherited from class org.apache.ignite.internal.util.lang.GridMetadataAwareAdapter

`addMeta, addMetaIfAbsent, addMetaIfAbsent, allMeta, clone, copyMeta, copyMeta, hasMeta, hasMeta, meta, putMetaIfAbsent, readExternalMeta, removeAllMeta, removeMeta, removeMeta, replaceMeta, writeExternalMeta`

### Methods inherited from class java.lang.Object

`finalize, getClass, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface org.apache.ignite.internal.processors.cache.transactions.IgniteInternalTx

`addMeta, commitVersion, commitVersion, concurrency, dht, done, endVersion, endVersion, finishFuture, hasTransforms, implicit, implicitSingle, internal, invalidate, invalidPartitions, ioPolicy, isInvalidate, isolation, isRollbackOnly, isSystemInvalidate, local, localResult, markFinalizing, markPreparing, meta, nodeId, onePhaseCommit, optimistic, otherNodeId, ownedVersion, pessimistic, proxy, readCommitted, remainingTime, removeMeta, repeatableRead, replicated, serializable, setRollbackOnly, size, startTime, startVersion, state, state, storeEnabled, storeUsed, subjectId, system, systemInvalidate, taskNameHash, threadId, timedOut, timeout, timeout, topologyVersion, topologyVersion, topologyVersionSnapshot, transactionNodes, user, writeVersion, writeVersion, xid, xidVersion`

### Methods inherited from interface org.apache.ignite.internal.processors.timeout.GridTimeoutObject

`endTime, onTimeout, timeoutId`

### Constructor Detail

#### GridNearTxLocal

    public GridNearTxLocal()

Empty constructor required for `Externalizable`.

#### GridNearTxLocal

    public GridNearTxLocal(GridCacheSharedContext ctx,
                   boolean implicit,
                   boolean implicitSingle,
                   boolean sys,
                   byte plc,
                   TransactionConcurrency concurrency,
                   TransactionIsolation isolation,
                   long timeout,
                   boolean storeEnabled,
                   int txSize,
                   @Nullable
                   UUID subjId,
                   int taskNameHash)

Parameters:
  `ctx` - Cache registry.
  `implicit` - Implicit flag.
  `implicitSingle` - Implicit with one key flag.
  `sys` - System flag.
  `plc` - IO policy.
  `concurrency` - Concurrency.
  `isolation` - Isolation.
  `timeout` - Timeout.
  `storeEnabled` - Store enabled flag.
  `txSize` - Transaction size.
  `subjId` - Subject ID.
  `taskNameHash` - Task name hash code.

### Method Detail

#### near

    public boolean near()

Specified by:
  `near` in interface `IgniteInternalTx`
Overrides:
  `near` in class `IgniteTxAdapter`
Returns:
  `True` if near transaction.

#### colocated

    public boolean colocated()

Specified by:
  `colocated` in interface `IgniteInternalTx`
Overrides:
  `colocated` in class `IgniteTxAdapter`
Returns:
  `True` if dht colocated transaction.

#### nearXidVersion

    @Nullable
    public GridCacheVersion nearXidVersion()

Specified by:
  `nearXidVersion` in interface `IgniteInternalTx`
Overrides:
  `nearXidVersion` in class `IgniteTxAdapter`
Returns:
  Near transaction ID.

#### enforceSerializable

    public boolean enforceSerializable()

For Partitioned caches, this flag is `false` for remote DHT and remote NEAR transactions because serializability of transaction is enforced on primary node. All other transaction types must enforce it.

Specified by:
  `enforceSerializable` in interface `IgniteInternalTx`
Overrides:
  `enforceSerializable` in class `IgniteTxAdapter`
Returns:
  Enforce serializable flag.

#### nearNodeId

    protected UUID nearNodeId()

Specified by:
  `nearNodeId` in class `GridDhtTxLocalAdapter`
Returns:
  Near node id.

#### nearFutureId

    protected IgniteUuid nearFutureId()

Specified by:
  `nearFutureId` in class `GridDhtTxLocalAdapter`
Returns:
  Near future ID.

#### addReader

    protected IgniteInternalFuture<Boolean> addReader(long msgId,
                                          GridDhtCacheEntry cached,
                                          IgniteTxEntry entry,
                                          AffinityTopologyVersion topVer)

Adds reader to cached entry.

Specified by:
  `addReader` in class `GridDhtTxLocalAdapter`
Parameters:
  `msgId` - Message ID.
  `cached` - Cached entry.
  `entry` - Transaction entry.
  `topVer` - Topology version.
Returns:
  `True` if reader was added as a result of this call.

#### sendFinishReply

    protected void sendFinishReply(boolean commit,
                       @Nullable
                       Throwable err)

Specified by:
  `sendFinishReply` in class `GridDhtTxLocalAdapter`
Parameters:
  `commit` - Commit flag.
  `err` - Error, if any.

#### clearPrepareFuture

    protected void clearPrepareFuture(GridDhtTxPrepareFuture fut)

Removes previously created prepare future from atomic reference.

Specified by:
  `clearPrepareFuture` in class `GridDhtTxLocalAdapter`
Parameters:
  `fut` - Expected future.

#### syncCommit

    public boolean syncCommit()

Specified by:
  `syncCommit` in interface `IgniteInternalTx`
Overrides:
  `syncCommit` in class `IgniteTxAdapter`
Returns:
  `True` if transaction is configured with synchronous commit flag.

#### syncRollback

    public boolean syncRollback()

Specified by:
  `syncRollback` in interface `IgniteInternalTx`
Overrides:
  `syncRollback` in class `IgniteTxAdapter`
Returns:
  `True` if transaction is configured with synchronous rollback flag.

#### markForBackupCheck

    public void markForBackupCheck()

Marks transaction to check if commit on backup.

#### onNeedCheckBackup

    public boolean onNeedCheckBackup()

Returns:
  If need to check tx commit on backup.

#### needCheckBackup

    public boolean needCheckBackup()

Returns:
  If backup check was requested.

#### nearLocallyMapped

    public boolean nearLocallyMapped()

Returns:
  `True` if transaction contains at least one near cache key mapped to the local node.

#### nearLocallyMapped

    public void nearLocallyMapped(boolean nearLocallyMapped)

Parameters:
  `nearLocallyMapped` - `True` if transaction contains near key mapped to the local node.

#### colocatedLocallyMapped

    public boolean colocatedLocallyMapped()

Returns:
  `True` if transaction contains colocated key mapped to the local node.

#### colocatedLocallyMapped

    public void colocatedLocallyMapped(boolean colocatedLocallyMapped)

Parameters:
  `colocatedLocallyMapped` - `True` if transaction contains colocated key mapped to the local node.

#### ownsLockUnsafe

    public boolean ownsLockUnsafe(GridCacheEntryEx entry)

Specified by:
  `ownsLockUnsafe` in interface `IgniteInternalTx`
Overrides:
  `ownsLockUnsafe` in class `IgniteTxAdapter`
Parameters:
  `entry` - Entry to check.
Returns:
  `True` if lock is owned.

#### ownsLock

    public boolean ownsLock(GridCacheEntryEx entry)
                     throws GridCacheEntryRemovedException

Specified by:
  `ownsLock` in interface `IgniteInternalTx`
Overrides:
  `ownsLock` in class `IgniteTxAdapter`
Parameters:
  `entry` - Entry to check.
Returns:
  `True` if lock is owned.
Throws:
  `GridCacheEntryRemovedException` - If entry has been removed.

#### optimisticLockEntries

    public Collection<IgniteTxEntry> optimisticLockEntries()

Gets a list of entries that needs to be locked on the next step of prepare stage of optimistic transaction.

Specified by:
  `optimisticLockEntries` in interface `IgniteInternalTx`
Overrides:
  `optimisticLockEntries` in class `IgniteTxAdapter`
Returns:
  List of tx entries for optimistic locking.

#### optimisticLockEntries

    public void optimisticLockEntries(Collection<IgniteTxEntry> optimisticLockEntries)

Parameters:
  `optimisticLockEntries` - Optimistic lock entries.

#### loadMissing

    public IgniteInternalFuture<Void> loadMissing(GridCacheContext cacheCtx,
                                         boolean readThrough,
                                         boolean async,
                                         Collection<KeyCacheObject> keys,
                                         boolean skipVals,
                                         boolean needVer,
                                         boolean keepBinary,
                                         GridInClosure3<KeyCacheObject,Object,GridCacheVersion> c)

Specified by:
  `loadMissing` in interface `IgniteTxLocalEx`
Overrides:
  `loadMissing` in class `IgniteTxLocalAdapter`
Parameters:
  `cacheCtx` - Cache context.
  `readThrough` - Read through flag.
  `async` - if `True`, then loading will happen in a separate thread.
  `keys` - Keys.
  `skipVals` - Skip values flag.
  `needVer` - If `true` version is required for loaded values.
  `c` - Closure to be applied for loaded values.
Returns:
  Future with `True` value if loading took place.

#### updateExplicitVersion

    protected void updateExplicitVersion(IgniteTxEntry txEntry,
                             GridCacheEntryEx entry)
                                  throws GridCacheEntryRemovedException

Updates explicit version for tx entry based on current entry lock owner.

Overrides:
  `updateExplicitVersion` in class `IgniteTxLocalAdapter`
Parameters:
  `txEntry` - Tx entry to update.
  `entry` - Entry.
Throws:
  `GridCacheEntryRemovedException` - If entry was concurrently removed.

#### removeMapping

    public boolean removeMapping(UUID nodeId)

Overrides:
  `removeMapping` in class `GridDhtTxLocalAdapter`
Parameters:
  `nodeId` - Undo mapping.
Returns:
  `True` if mapping was removed.

#### addKeyMapping

    public void addKeyMapping(IgniteTxKey key,
                     ClusterNode node)

Adds key mapping to dht mapping.

Parameters:
  `key` - Key to add.
  `node` - Node this key mapped to.

#### markExplicit

    public boolean markExplicit(UUID nodeId)

Parameters:
  `nodeId` - Node ID to mark with explicit lock.
Returns:
  `True` if mapping was found.

#### onOwnerChanged

    public boolean onOwnerChanged(GridCacheEntryEx entry,
                         GridCacheMvccCandidate owner)

Callback invoked whenever there is a lock that has been acquired by this transaction for any of the participating entries.

Specified by:
  `onOwnerChanged` in interface `IgniteInternalTx`
Overrides:
  `onOwnerChanged` in class `IgniteTxLocalAdapter`
Parameters:
  `entry` - Cache entry.
  `owner` - Lock candidate that won ownership of the lock.
Returns:
  `True` if transaction cared about notification.

#### finish

    public boolean finish(boolean commit)
                   throws IgniteCheckedException

Finishes transaction (either commit or rollback).

Specified by:
  `finish` in interface `IgniteTxLocalEx`
Overrides:
  `finish` in class `GridDhtTxLocalAdapter`
Parameters:
  `commit` - `True` if commit, `false` if rollback.
Returns:
  `True` if state has been changed.
Throws:
  `IgniteCheckedException` - If finish failed.

#### prepareAsync

    public IgniteInternalFuture<?> prepareAsync()

Prepare stage.

Returns:
  Future for prepare step.

#### commitAsync

    public IgniteInternalFuture<IgniteInternalTx> commitAsync()

Asynchronously commits this transaction by initiating `two-phase-commit` process.

Returns:
  Future for commit operation.

#### rollbackAsync

    public IgniteInternalFuture<IgniteInternalTx> rollbackAsync()

Asynchronously rollback this transaction.

Returns:
  Rollback future.

#### prepareAsyncLocal

    public IgniteInternalFuture<GridNearTxPrepareResponse> prepareAsyncLocal(@Nullable
                                                                    Collection<IgniteTxEntry> reads,
                                                                    @Nullable
                                                                    Collection<IgniteTxEntry> writes,
                                                                    Map<UUID,Collection<UUID>> txNodes,
                                                                    boolean last)

Prepares next batch of entries in dht transaction.

Parameters:
  `reads` - Read entries.
  `writes` - Write entries.
  `txNodes` - Transaction nodes mapping.
  `last` - `True` if this is last prepare request.
Returns:
  Future that will be completed when locks are acquired.

#### commitAsyncLocal

    public IgniteInternalFuture<IgniteInternalTx> commitAsyncLocal()

Commits local part of colocated transaction.

Returns:
  Commit future.

#### rollbackAsyncLocal

    public IgniteInternalFuture<IgniteInternalTx> rollbackAsyncLocal()

Rolls back local part of colocated transaction.

Returns:
  Commit future.

#### lockAllAsync

    public <K> IgniteInternalFuture<GridCacheReturn> lockAllAsync(GridCacheContext cacheCtx,
                                                         Collection<? extends K> keys,
                                                         boolean implicit,
                                                         boolean read,
                                                         long accessTtl,
                                                         boolean skipStore,
                                                         boolean keepBinary)

Type Parameters:
  `K` - Key type.
Parameters:
  `cacheCtx` - Cache context.
  `keys` - Keys.
  `implicit` - Implicit flag.
  `read` - Read flag.
  `accessTtl` - Access ttl.
  `skipStore` - Skip store flag.
Returns:
  Future with respond.

#### entryEx

    protected GridCacheEntryEx entryEx(GridCacheContext cacheCtx,
                           IgniteTxKey key)

Gets cache entry for given key.

Overrides:
  `entryEx` in class `IgniteTxLocalAdapter`
Parameters:
  `cacheCtx` - Cache context.
  `key` - Key.
Returns:
  Cache entry.

#### entryEx

    protected GridCacheEntryEx entryEx(GridCacheContext cacheCtx,
                           IgniteTxKey key,
                           AffinityTopologyVersion topVer)

Gets cache entry for given key and topology version.

Overrides:
  `entryEx` in class `IgniteTxLocalAdapter`
Parameters:
  `cacheCtx` - Cache context.
  `key` - Key.
  `topVer` - Topology version.
Returns:
  Cache entry.

#### accessPolicy

    protected IgniteCacheExpiryPolicy accessPolicy(GridCacheContext ctx,
                                       IgniteTxKey key,
                                       @Nullable
                                       javax.cache.expiry.ExpiryPolicy expiryPlc)

Overrides:
  `accessPolicy` in class `IgniteTxLocalAdapter`
Parameters:
  `ctx` - Cache context.
  `key` - Key.
  `expiryPlc` - Expiry policy.
Returns:
  Expiry policy wrapper for entries accessed locally in optimistic transaction.

#### accessPolicy

    protected IgniteCacheExpiryPolicy accessPolicy(GridCacheContext cacheCtx,
                                       Collection<KeyCacheObject> keys)

Overrides:
  `accessPolicy` in class `IgniteTxLocalAdapter`
Parameters:
  `cacheCtx` - Cache context.
  `keys` - Keys.
Returns:
  Expiry policy.

#### close

    public void close()
               throws IgniteCheckedException

Ends the transaction. Transaction will be rolled back if it has not been committed.

Specified by:
  `close` in interface `AutoCloseable`
Specified by:
  `close` in interface `IgniteInternalTx`
Overrides:
  `close` in class `IgniteTxAdapter`
Throws:
  `IgniteCheckedException` - If transaction could not be gracefully ended.

#### currentPrepareFuture

    @Nullable
    public IgniteInternalFuture<?> currentPrepareFuture()

Specified by:
  `currentPrepareFuture` in interface `IgniteInternalTx`
Overrides:
  `currentPrepareFuture` in class `IgniteTxAdapter`
Returns:
  Future for transaction prepare if prepare is in progress.

#### onRemap

    public void onRemap(AffinityTopologyVersion topVer)

Specified by:
  `onRemap` in interface `IgniteInternalTx`
Overrides:
  `onRemap` in class `IgniteTxAdapter`
Parameters:
  `topVer` - New topology version.

#### hasRemoteLocks

    public void hasRemoteLocks(boolean hasRemoteLocks)

Parameters:
  `hasRemoteLocks` - `True` if tx has remote locks acquired.

#### hasRemoteLocks

    public boolean hasRemoteLocks()

Returns:
  `True` if tx has remote locks acquired.

#### toString

    public String toString()

Overrides:
  `toString` in class `GridDhtTxLocalAdapter`

2015 Copyright © Apache Software Foundation

Follow @ApacheIgnite

Ignite Fabric | : ver. 1.5.0.final
Release Date | : December 29 2015